/*
	  JoL Eraser
	     v 0.2.2.0
		 
	      Vilya
		
	25/06/2006
*/

/*
	Numro de version.
*/
var version = "0.2.2.0";

/*
	Dfinition de l'emplacement des scripts.
*/
var eraseTopBarre			= "chrome://joleraser/content/scripts/eraseTopBarre.js";
var eraseBanniere			= "chrome://joleraser/content/scripts/eraseBanniere.js";
var eraseJolBarre			= "chrome://joleraser/content/scripts/eraseJolBarre.js";
var eraseAnnonce			= "chrome://joleraser/content/scripts/eraseAnnonce.js";
var eraseActualites			= "chrome://joleraser/content/scripts/eraseActualites.js";
var eraseLicence			= "chrome://joleraser/content/scripts/eraseLicence.js";
var eraseSectionsRepliees	= "chrome://joleraser/content/scripts/eraseSectionsRepliees.js";
var eraseSujetsFermes		= "chrome://joleraser/content/scripts/eraseSujetsFermes.js";
var eraseJoLBarreButtons	= "chrome://joleraser/content/scripts/eraseJoLBarreButtons.js";

var addMenuNavigation		= "chrome://joleraser/content/scripts/addMenuNavigation.js";

var handleFriendList		= "chrome://joleraser/content/scripts/handleFriendList.js";
var handleFoeList			= "chrome://joleraser/content/scripts/handleFoeList.js";

var compteur = 0;

/*
	Fonction appele lors de l'vnement onload.
*/
function joleraserDisplayCheck()
{
	setTimeout("joleraseCheck()", 500);
    return true;
}

/*
	On vrifie que l'utilisateur est bien sur le domaine "forums.jeuxonline.info" en parcourant les diffrentes frames.
*/
function joleraseCheck(win)
{
	if (!win)
	{
		var win = window.self;
	}
	for (var i = 0; win.frames && i < win.frames.length; i++)
	{
		joleraseCheck(win.frames[i]);
    }
	if(win.location.toString().toLowerCase().indexOf("http://forums.jeuxonline.info")==0)
	{
		joleraseParse(win);
	}
	return true;
}

/*
	Fonction traitant une fentre en fonction des prfrences.
*/
function joleraseParse(win)
{

	//Instanciation de l'interface du systme de prfrences
	var prefObj = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var Branch = prefObj.getBranch("joltool.");
	//Rcupration des prfrences
	var afficher_menu_navigation_horizontal	= Branch.prefHasUserValue("afficher_menu_navigation_horizontal") && Branch.getBoolPref("afficher_menu_navigation_horizontal"); //default:false
	var masquer_barre_superieure	= Branch.prefHasUserValue("masquer_barre_superieure") && Branch.getBoolPref("masquer_barre_superieure"); // default:false
	var masquer_barre_jol			= Branch.prefHasUserValue("masquer_barre_jol") && Branch.getBoolPref("masquer_barre_jol"); // default:false
	var masquer_annonces			= !Branch.prefHasUserValue("masquer_annonces") || Branch.getBoolPref("masquer_annonces"); // default:true
	var masquer_banniere			= !Branch.prefHasUserValue("masquer_banniere") || Branch.getBoolPref("masquer_banniere"); // default:true
	var masquer_actualites			= !Branch.prefHasUserValue("masquer_actualites") || Branch.getBoolPref("masquer_actualites"); // default:true
	var masquer_licences			= !Branch.prefHasUserValue("masquer_licences") || Branch.getBoolPref("masquer_licences"); // default:true
	var masquer_sections_repliees	= Branch.prefHasUserValue("masquer_sections_repliees") && Branch.getBoolPref("masquer_sections_repliees"); // default:false
	var masquer_sujets_fermes		= Branch.prefHasUserValue("masquer_sujets_fermes") && Branch.getBoolPref("masquer_sujets_fermes"); // default:false
	var utiliser_liste_amis			= !Branch.prefHasUserValue("use_friend_list") || Branch.getBoolPref("use_friend_list"); // default:true
	var utiliser_liste_ignores		= !Branch.prefHasUserValue("use_foe_list") || Branch.getBoolPref("use_foe_list"); // default:true
	if (Branch.prefHasUserValue("user_id"))
	{
		var user_id = Branch.getIntPref("user_id");
	} else { var user_id = 0 }
	if (Branch.prefHasUserValue("personnaliser_barre_jol"))
	{
		var personnaliser_barre_jol = Branch.getCharPref("personnaliser_barre_jol");
	} else { var personnaliser_barre_jol = "0;0;1;1;0;1;0;0;0" }
	if (joleraser_isPreferenceSet("joltool.friend-list"))
	{
		var friend_list = joleraser_getStringPreference("joltool.friend-list", true)
	} else { var friend_list = "" }
	if (joleraser_isPreferenceSet("joltool.foe-list"))
	{
		var foe_list = joleraser_getStringPreference("joltool.foe-list", true)
	} else { var foe_list = "" }
	
	//Insertion des paramtres dans la page
	if (!win.document.getElementById("personnaliser_barre_jol"))
	{
		var newAElement = win.document.createElement("a");
		newAElement.setAttribute("value", personnaliser_barre_jol);
		newAElement.setAttribute("id", "personnaliser_barre_jol");
		if (win.document.getElementsByTagName("body"))
		{
			win.document.getElementsByTagName("body")[0].appendChild(newAElement);
		}
	}
	if (!win.document.getElementById("friend_list"))
	{
		var newAElement = win.document.createElement("a");
		newAElement.setAttribute("value", friend_list);
		newAElement.setAttribute("id", "friend_list");
		if (win.document.getElementsByTagName("head"))
		{
			win.document.getElementsByTagName("head")[0].appendChild(newAElement);
		}
	}
	if (!win.document.getElementById("foe_list"))
	{
		var newAElement = win.document.createElement("a");
		newAElement.setAttribute("value", foe_list);
		newAElement.setAttribute("id", "foe_list");
		if (win.document.getElementsByTagName("head"))
		{
			win.document.getElementsByTagName("head")[0].appendChild(newAElement);
		}
	}
	
	//Rajout des scripts en fonction des prfrences
	if (afficher_menu_navigation_horizontal) { addScript(win, addMenuNavigation, "addMenuNavigation"); }
	if (masquer_barre_superieure) { addScript(win, eraseTopBarre, "eraseTopBarre"); }
	if (masquer_banniere) { addScript(win, eraseBanniere, "eraseBanniere"); }
	if (masquer_barre_jol) { addScript(win, eraseJolBarre, "eraseJolBarre"); } else { addScript(win, eraseJoLBarreButtons, "eraseJoLBarreButtons"); }
	if (masquer_annonces) { addScript(win, eraseAnnonce, "eraseAnnonce"); }
	if (masquer_actualites) { addScript(win, eraseActualites, "eraseActualites"); }
	if (masquer_licences) { setTimeout(function() { addScript(win, eraseLicence, "eraseLicence"); }, 1000); }
	if (masquer_sections_repliees) { setTimeout(function() { addScript(win, eraseSectionsRepliees, "eraseSectionsRepliees"); }, 1000); }
	if (masquer_sujets_fermes) { setTimeout(function() { addScript(win, eraseSujetsFermes, "eraseSujetsFermes"); }, 1000); }
	if (utiliser_liste_amis) { setTimeout(function() { addScript(win, handleFriendList, "handleFriendList"); }, 1000); }
	if (utiliser_liste_ignores) { setTimeout(function() { addScript(win, handleFoeList, "handleFoeList"); }, 1000); }
	
	/*
		Vrification de la version en cours
	*/
	if (!compteur>0)
	{
		verifieVersion();
		compteur++;
	}
	
	return true;
}

/*
	Fonction rcuprant le numro de version en cours et affichant un message s'il existe une mise  jour
*/
function verifieVersion()
{
	//Envoi des informations de suivi
	var xmlhttp = new XMLHttpRequest();
	xmlhttp.onreadystatechange = function()
	{
		if (xmlhttp.readyState == 4 && (xmlhttp.status == 200 || xmlhttp.status == 304))
		{
			var versionEnCours = xmlhttp.responseText;
			if (versionEnCours > version)
			{
				alert("Une nouvelle version de JoL Eraser est disponible. Vous pouvez la mettre a jour directement depuis le menu Extension de votre navigateur ou la telecharger sur http://vilya.jol.free.fr/joleraser/installation.html");
			}
		}
	}
	xmlhttp.open("POST", "http://vilya.jol.free.fr/joleraser/update.php",true);
	xmlhttp.setRequestHeader('Content-Type','application/x-www-form-urlencoded');
	xmlhttp.send(null);
}

/*
	Pour rgler le problme de l'excution du script pendant le chargement de la page (et donc l'oubli d'lments) on insre 2 fois le script  3 secondes d'intervalle.
*/
function addScript(win, source, id)
{
	addScriptVersion(win, source, id, "1");
	setTimeout(function() { addScriptVersion(win, source, id, "2"); }, 3000);
}

/*
	Fonction rajoutant le script  la page. On s'assure de la sorte que le script n'est excut qu'une seule fois.
	Le problme (il en faut bien un) est que l'vnement onload est dclench avant le chargement de la page par la fin du chargement des frames de la page.
	Dans le cas de JoL il s'agit des publicits.
	Il se peut donc que certains lments de la page ne soient pas encore chargs par le navigateur au moment de l'excution des scripts qui n'ont alors aucun effet.
	Voir l'utilisation de la fonction setTimeout pour dcaler dans le temps l'excution d'une fonction dans la fonction prcdente (joleraseParse).
*/
function addScriptVersion(win, source, id, version)
{
	if (!win.document.getElementById(id + version))
	{
		var aList=win.document.getElementsByTagName('html');
		var newScript = win.document.createElement('script');
		newScript.setAttribute('language','JavaScript');
		newScript.setAttribute("type","text/javascript");
		newScript.setAttribute('id', "" + id + version);
		newScript.setAttribute("src", source);
		aList[0].appendChild(newScript);
	}
	return true;
}