/*
	Rajoute le menu de navigation horizontal
	On commence par aller chercher le nouveau menu dont on rcupre les liens.
	On les remet en forme et les insre dans le document.
*/

/*
	Fonction recherchant la premire table frre de l'lement pass en argument et lui accolant le menu de navigation
*/
function addMenuNavigation(element)
{
	if (!element)
	{
		return true;
	}
	if (element.nodeType == 1 && element.tagName == "TABLE")
	{
		element.parentNode.insertBefore(newDivElement.cloneNode(true), element.nextSibling);
		return true;
	}
	addMenuNavigation(element.nextSibling);
}


/*
	On vrifie que le menu existe bien. On ne va pas l'inventer ^^
*/
if (document.getElementById("intraforums_menu"))
{
	var aTab = document.getElementById("intraforums_menu").getElementsByTagName("a");
	if (!(aTab.length > 20) && !(document.getElementById("ligneNavigation"))) //Ca c'est pour viter de crer un menu monstrueux quand on se trouve sur la page d'accueil du forum ou au premier niveau
	{
		var newDivElement = document.createElement("p");
		newDivElement.setAttribute("id", "ligneNavigation");
		newDivElement.setAttribute("align", "center");
		if (aTab.length > 1)
		{
			for (var i = 0 ; i<aTab.length - 1 ; i++)
			{
				var newAElement = aTab[i].cloneNode(true);
				newAElement.setAttribute("class", "smallfont");
				newDivElement.appendChild(newAElement);
				var newSeparator = document.createTextNode(" - ");
				newDivElement.appendChild(newSeparator);
			}
			var newAElement = aTab[aTab.length - 1].cloneNode(true);
			newAElement.setAttribute("class", "smallfont");
			newDivElement.appendChild(newAElement);
		} else
		{
			var newAElement = aTab[0].cloneNode(true);
			newAElement.setAttribute("class", "smallfont");
			newDivElement.appendChild(newAElement);
		}
		
		var tableElementTab = document.getElementsByTagName("table");
		for (var i = 0 ; i<tableElementTab.length ; i++)
		{
			if (tableElementTab[i].getAttribute("class") && tableElementTab[i].getAttribute("class").indexOf("barreNavigation") != -1)
			{
				//Ajout du menu aprs la table ombre
				addMenuNavigation(tableElementTab[i].nextSibling);
			}
		}
	}
}